;
;   MSX support by Giovanni Nunes - https://github.com/plainspooky
;                  Emiliano Fraga - https://github.com/efraga-msx
;

;
; MSX BIOS
;
CHKRAM         equ 0x0000
RDSLT          equ 0x000C
WRSLT          equ 0x0014
CALSLT         equ 0x001C
DCOMPR         equ 0x0020
ENASLT         equ 0x0024
CALLF          equ 0x0030
KEYINT         equ 0x0038
INITIO         equ 0x003B
INIFNK         equ 0x003E
DISSCR         equ 0x0041
ENASCR         equ 0x0044
WRTVDP         equ 0x0047
RDVRM          equ 0x004A
WRTVRM         equ 0x004D
SETRD          equ 0x0050
SETWRT         equ 0x0053
FILVRM         equ 0x0056
LDIRMV         equ 0x0059
LDIRVM         equ 0x005C
CHGMOD         equ 0x005F
CHGCLR         equ 0x0062
NMI            equ 0x0066
CLRSPR         equ 0x0069
INITXT         equ 0x006C
INIT32         equ 0x006F
INIGRP         equ 0x0072
INIMLT         equ 0x0075
CALPAT         equ 0x0084
CALATR         equ 0x0087
GSPSIZ         equ 0x008A
GRPPRT         equ 0x008D
GICINI         equ 0x0090
WRTPSG         equ 0x0093
RDPSG          equ 0x0096
STRTMS         equ 0x0099
CHSNS          equ 0x009C
CHGET          equ 0x009F
CHPUT          equ 0x00A2
LPTOUT         equ 0x00A5
LPTSTT         equ 0x00A8
PINLIN         equ 0x00AE
INLIN          equ 0x00B1
QINLIN         equ 0x00B4
BREAKX         equ 0x00B7
BEEP           equ 0x00C0
CLS            equ 0x00C3
POSIT          equ 0x00C6
ERAFNK         equ 0x00CC
DSPFNK         equ 0x00CF
TOTEXT         equ 0x00D2
GTSTCK         equ 0x00D5
GTTRIG         equ 0x00D8
GTPAD          equ 0x00DB
GTPDL          equ 0x00DE
TAPION         equ 0x00E1
TAPIN          equ 0x00E4
TAPIOF         equ 0x00E7
TAPOON         equ 0x00EA
TAPOUT         equ 0x00ED
TAPOOF         equ 0x00F0
STMOTR         equ 0x00F3
LFTQ           equ 0x00F6
PUTQ           equ 0x00F9
RIGHTC         equ 0x00FC
LEFTC          equ 0x00FF
UPC            equ 0x0102
TUPC           equ 0x0105
DOWNC          equ 0x0108
TDOWNC         equ 0x010B
SCALXY         equ 0x010E
MAPXYC         equ 0x0111
FETCHC         equ 0x0114
STOREC         equ 0x0117
SETATR         equ 0x011A
READC          equ 0x011D
SETC           equ 0x0120
NSETCX         equ 0x0123
CHGCAP         equ 0x0132
CHGSND         equ 0x0135
RSLREG         equ 0x0138
WSLREG         equ 0x013B
RDVDP          equ 0x013E
SNSMAT         equ 0x0141
KILBUF         equ 0x0156
CALBAS         equ 0x0159

;
; MSX System Hooks
;
HKEYI          equ 0xFD9A
HTIMI          equ 0xFD9F
HCHPU          equ 0xFDA4
HDSPC          equ 0xFDA9
HERAC          equ 0xFDAE
HDSPF          equ 0xFDB3
HERAF          equ 0xFDB8
HTOTE          equ 0xFDBD
HCHGE          equ 0xFDC2
HINIP          equ 0xFDC7
HKEYC          equ 0xFDCC
HKEYA          equ 0xFDD1
HNMI           equ 0xFDD6
HPINL          equ 0xFDDB
HQINL          equ 0xFDE0
HINLI          equ 0xFDE5
HONGO          equ 0xFDEA
HDSKO          equ 0xFDEF
HSETS          equ 0xFDF4
HNAME          equ 0xFDF9
HKILL          equ 0xFDFE
HIPL           equ 0xFE03
HCOPY          equ 0xFE08
HCMD           equ 0xFE0D
HDSKI          equ 0xFE17
HATTR          equ 0xFE1C
HLSET          equ 0xFE21
HRSET          equ 0xFE26
HFIEL          equ 0xFE2B
HMKI           equ 0xFE30
HMKS           equ 0xFE35
HMKD           equ 0xFE3A
HCVI           equ 0xFE3F
HCVS           equ 0xFE44
HCVD           equ 0xFE49
HGETP          equ 0xFE4E
HSETF          equ 0xFE53
HNOFO          equ 0xFE58
HNULO          equ 0xFE5D
HNTFL          equ 0xFE62
HMERG          equ 0xFE67
HSAVE          equ 0xFE6C
HBINS          equ 0xFE71
HBINL          equ 0xFE76
HFILE          equ 0xFE7B
HDGET          equ 0xFE80
HFILO          equ 0xFE85
HINDS          equ 0xFE8A
HRSLF          equ 0xFE8F
HSAVD          equ 0xFE94
HLOC           equ 0xFE99
HLOF           equ 0xFE9E
HEOF           equ 0xFEA3
HFPOS          equ 0xFEA8
HBAKU          equ 0xFEAD
HPARD          equ 0xFEB2
HNODE          equ 0xFEB7
HPOSD          equ 0xFEBC
HDEVN          equ 0xFEC1
HGEND          equ 0xFEC6
HRUNC          equ 0xFECB
HCLEA          equ 0xFED0
HLOPD          equ 0xFED5
HSTKE          equ 0xFEDA
HISFL          equ 0xFEDF
HOUTD          equ 0xFEE4
HCRDO          equ 0xFEE9
HDSKC          equ 0xFEEE
HDOGR          equ 0xFEF3
HPRGE          equ 0xFEF8
HERRP          equ 0xFEFD
HERRF          equ 0xFF02
HREAD          equ 0xFF07
HMAIN          equ 0xFF0C
HDIRD          equ 0xFF11
HFINI          equ 0xFF16
HFINE          equ 0xFF1B
HCRUN          equ 0xFF20
HCRUS          equ 0xFF25
HISRE          equ 0xFF2A
HNTFN          equ 0xFF2F
HNOTR          equ 0xFF34
HSNGF          equ 0xFF39
HNEWS          equ 0xFF3E
HGONE          equ 0xFF43
HCHRG          equ 0xFF48
HRETU          equ 0xFF4D
HPRTF          equ 0xFF52
HCOMP          equ 0xFF57
HFINP          equ 0xFF5C
HTRMN          equ 0xFF61
HFRME          equ 0xFF66
HNTPL          equ 0xFF6B
HEVAL          equ 0xFF70
HOKNO          equ 0xFF75
HFING          equ 0xFF7A
HISMI          equ 0xFF7F
HWIDT          equ 0xFF84
HLIST          equ 0xFF89
HBUFL          equ 0xFF8E
HFRQI          equ 0xFF93
HSCNE          equ 0xFF98
HFRET          equ 0xFF9D
HPTRG          equ 0xFFA2
HPHYD          equ 0xFFA7
HFORM          equ 0xFFAC
HERRO          equ 0xFFB1
HLPTO          equ 0xFFB6
HLPTS          equ 0xFFBB
HSCRE          equ 0xFFC0
HPLAY          equ 0xFFC5

;
; MSX system variables
;
USRTAB0        equ 0xF39A
USRTAB1        equ 0xF39C
USRTAB2        equ 0xF39E
USRTAB3        equ 0xF3A0
USRTAB4        equ 0xF3A2
USRTAB5        equ 0xF3A4
USRTAB6        equ 0xF3A6
USRTAB7        equ 0xF3A8
USRTAB8        equ 0xF3AA
USRTAB9        equ 0xF3AC
LINL40         equ 0xF3AE
LINL32         equ 0xF3AF
LINLEN         equ 0xF3B0
CRTCNT         equ 0xF3B1
TXTNAM         equ 0xF3B3
TXTCOL         equ 0xF3B5
TXTCGP         equ 0xF3B7
TXTATR         equ 0xF3B9
TXTPAT         equ 0xF3BB
T32NAM         equ 0xF3BD
T32COL         equ 0xF3BF
T32CGP         equ 0xF3C1
T32ATR         equ 0xF3C3
T32PAT         equ 0xF3C5
GRPNAM         equ 0xF3C7
GRPCOL         equ 0xF3C9
GRPCGP         equ 0xF3CB
GRPATR         equ 0xF3CD
GRPPAT         equ 0xF3CF
MLTNAM         equ 0xF3D1
MLTCOL         equ 0xF3D3
MLTCGP         equ 0xF3D5
MLTATR         equ 0xF3D7
MLTPAT         equ 0xF3D9
CLIKSW         equ 0xF3DB
CSRY           equ 0xF3DC
CSRX           equ 0xF3DD
CONSDFG        equ 0xF3DE
RG0SAV         equ 0xF3DF
RG1SAV         equ 0xF3E0
RG2SAV         equ 0xF3E1
RG3SAV         equ 0xF3E2
RG4SAV         equ 0xF3E3
RG5SAV         equ 0xF3E4
RG6SAV         equ 0xF3E5
RG7SAV         equ 0xF3E6
STATFL         equ 0xF3E7
TRGFLG         equ 0xF3E8
FORCLR         equ 0xF3E9
BAKCLR         equ 0xF3EA
BDRCLR         equ 0xF3EB
MAXUPD         equ 0xF3EC
MINUPD         equ 0xF3EF
ATRBYT         equ 0xF3F2
QUEUES         equ 0xF3F3
FRCNEW         equ 0xF3F5
SCNCNT         equ 0xF3F6
REPCNT         equ 0xF3F7
PUTPNT         equ 0xF3F8
GETPNT         equ 0xF3FA
CS1200         equ 0xF3FC
CS2400         equ 0xF401
CASLOW         equ 0xF406
CASHIGH        equ 0xF408
HEADER         equ 0xF40A
ASPCT1         equ 0xF40B
ASPCT2         equ 0xF40D
ENDPRG         equ 0xF40F
ERRFLG         equ 0xF414
LPTPOS         equ 0xF415
PRTFLG         equ 0xF416
NTMSXP         equ 0xF417
RAWPRT         equ 0xF418
VLZADR         equ 0xF419
VLZDAT         equ 0xF41B
KBFMIN         equ 0xF41E
KBUF           equ 0xF41F
BUFMIN         equ 0xF55D
BUF            equ 0xF55E
TTYPOS         equ 0xF661
DIMFLG         equ 0xF662
VALTYP         equ 0xF663
DORES          equ 0xF664
DONUM          equ 0xF665
CONTXT         equ 0xF666
CONSAV         equ 0xF668
CONTYP         equ 0xF669
CONLO          equ 0xF66A
STKTOP         equ 0xF674
TXTTAB         equ 0xF676
TEMPPT         equ 0xF678
TEMPST         equ 0xF67A
DSCTMP         equ 0xF698
FRETOP         equ 0xF69B
TEMP3          equ 0xF69D
TEMP8          equ 0xF69F
ENDFOR         equ 0xF6A1
DATLIN         equ 0xF6A3
SUBFLG         equ 0xF6A5
FLGINP         equ 0xF6A6
TEMP           equ 0xF6A7
PTRFLG         equ 0xF6A9
AUTFLG         equ 0xF6AA
AUTLIN         equ 0xF6AB
AUTINC         equ 0xF6AD
SAVTXT         equ 0xF6AF
ERRLIN         equ 0xF6B3
DOT            equ 0xF6B5
ERRTXT         equ 0xF6B7
ONELIN         equ 0xF6B9
ONEFLG         equ 0xF6BB
TEMP2          equ 0xF6BC
OLDLIN         equ 0xF6BE
OLDTXT         equ 0xF6C0
VARTAB         equ 0xF6C2
ARYTAB         equ 0xF6C4
STREND         equ 0xF6C6
DATPTR         equ 0xF6C8
DEFTBL         equ 0xF6CA
PRMSTK         equ 0xF6E4
PRMLEN         equ 0xF6E6
PARM1          equ 0xF6E8
PRMPRV         equ 0xF74C
PRMLN2         equ 0xF74E
PARM2          equ 0xF750
PRMFLG         equ 0xF7B4
ARYTA2         equ 0xF7B5
NOFUNS         equ 0xF7B7
TEMP9          equ 0xF7B8
FUNACT         equ 0xF7BA
SWPTMP         equ 0xF7BC
TRCFLG         equ 0xF7C4
FBUFFR         equ 0xF7C5
DECTM2         equ 0xF7F2
DECCNT         equ 0xF7F4
DAC            equ 0xF7F6
ARGUSR         equ 0xF7F8
HOLD8          equ 0xF806
ARG            equ 0xF847
RNDX           equ 0xF857
MAXFIL         equ 0xF85F
FILTAB         equ 0xF860
NULBUF         equ 0xF862
PTRFIL         equ 0xF864
FILNAM         equ 0xF866
FILNM2         equ 0xF871
NLONLY         equ 0xF87C
SAVEND         equ 0xF87D
FNKSTR         equ 0xF87F
CGPNT          equ 0xF91F
NAMBAS         equ 0xF922
CGPBAS         equ 0xF924
PATBAS         equ 0xF926
ATRBAS         equ 0xF928
CLOC           equ 0xF92A
CMASK          equ 0xF92C
MINDEL         equ 0xF92D
MAXDEL         equ 0xF92F
ASPECT         equ 0xF931
CENCNT         equ 0xF933
CLINEF         equ 0xF935
CNPNTS         equ 0xF936
CPLOTF         equ 0xF938
CPCNT          equ 0xF939
CPCNT8         equ 0xF93B
CRCSUM         equ 0xF93D
CSTCNT         equ 0xF93F
CSCLXY         equ 0xF941
CSAVEA         equ 0xF942
CSAVEM         equ 0xF944
CXOFF          equ 0xF945
CYOFF          equ 0xF947
LOHMSK         equ 0xF949
LOHDIR         equ 0xF94A
LOHADR         equ 0xF94B
LOHCNT         equ 0xF94D
SKPCNT         equ 0xF94F
MOVCNT         equ 0xF951
PDIREC         equ 0xF953
LEPROG         equ 0xF954
RTPROG         equ 0xF955
MCLFLG         equ 0xF958
QUETAB         equ 0xF959
QUEBAK         equ 0xF971
VOICAQ         equ 0xF975
VOICBQ         equ 0xF9F5
VOICCQ         equ 0xFA75
RS2IQ          equ 0xFAF5
PRSCNT         equ 0xFB35
SAVSP          equ 0xFB36
VOICEN         equ 0xFB38
SAVVOL         equ 0xFB39
MCLLEN         equ 0xFB3B
MCLPTR         equ 0xFB3C
QUEUEN         equ 0xFB3E
MUSICF         equ 0xFB3F
PLACNT         equ 0xFB40
VCBA           equ 0xFB41
VCBB           equ 0xFB66
VCBC           equ 0xFB8B
ENSTOP         equ 0xFBB0
BASROM         equ 0xFBB1
LINTTB         equ 0xFBB2
FSTPOS         equ 0xFBCA
CURSAV         equ 0xFBCC
FNKSWI         equ 0xFBCD
FNKFLG         equ 0xFBCE
ONGSBF         equ 0xFBD8
OLDKEY         equ 0xFBDA
NEWKEY         equ 0xFBE5
KEYBUF         equ 0xFBF0
LINWRK         equ 0xFC18
PATWRK         equ 0xFC40
BOTTOM         equ 0xFC48
TRPTBL         equ 0xFC4C
RTYCNT         equ 0xFC9A
INTFLG         equ 0xFC9B
PADY           equ 0xFC9C
PADX           equ 0xFC9D
JIFFY          equ 0xFC9E
INTVAL         equ 0xFCA0
INTCNT         equ 0xFCA2
LOWLIM         equ 0xFCA4
WINWID         equ 0xFCA5
GRPHED         equ 0xFCA6
ESCCNT         equ 0xFCA7
INSFLG         equ 0xFCA8
CSTYLE         equ 0xFCAA
CAPST          equ 0xFCAB
KANAST         equ 0xFCAC
KANAMD         equ 0xFCAD
FLBMEM         equ 0xFCAE
SCRMOD         equ 0xFCAF
OLDSCR         equ 0xFCB0
CASPRV         equ 0xFCB1
BDRATR         equ 0xFCB2
GXPOS          equ 0xFCB3
GYPOS          equ 0xFCB5
GRPACX         equ 0xFCB7
GRPACY         equ 0xFCB9
DRWFLG         equ 0xFCBB
DRWSCL         equ 0xFCBC
DRWANG         equ 0xFCBD
RUNBNF         equ 0xFCBE
SAVENT         equ 0xFCBF
EXPTBL         equ 0xFCC1
SLTTBL         equ 0xFCC5
SLTATR         equ 0xFCC9
SLTWRK         equ 0xFD09
PROCNM         equ 0xFD89
DEVICE         equ 0xFD99
CSRSW          equ 0xFCA9

